function [eigenvec Gw zeta pdf pdf0 pdf1 cdf aggw top1share top01share top001share thetaProxy01 thetaProxy001 top1thresh top01thresh top001thresh top0001thresh growth_top1 growth_top01 growth_top001 growth_top0001] = getSS(param,mu0,mu1,w0,Jm)
global rho alpha Delta pi

% Wealth grid
Nw = 1000;
wfactor=1e7;
GridRatio=1/2;
wunderbar = 0;
typicalPoint = w0;
aParam = wunderbar;
bParam = wfactor*typicalPoint;
cParam = typicalPoint;
sParam = (cParam^2-aParam*bParam)/(aParam + bParam - 2*cParam);
temp = linspace(log(aParam+sParam),log(bParam+sParam),Nw);
Gw = exp(temp) - sParam;
Nmed = floor(GridRatio*Nw);
Gw(1:Nmed) = linspace(aParam,Gw(Nmed),Nmed);
Gw=real(Gw);

% TPM conditional on birth
TPM_death = zeros(Nw);
ind0 = find(Gw < w0, 1, 'last');
if isempty(ind0) % x0 is below smallest grid point
    TPM_death(:,1) = 1;
elseif ind0 < Nw % x0 is strictly inside grid
    theta0 = (w0-Gw(ind0))/(Gw(ind0+1)-Gw(ind0));
    TPM_death(:,ind0) = 1-theta0; % convex combination
    TPM_death(:,ind0+1) = theta0;
else % x0 is above largest grid
    TPM_death(:,end) = 1;
end

% TPM conditional on surviving
PS=[ 1-Delta*param(3) Delta*param(3); 0 1];
PJ=1;
xGrid=Gw;
Gstj=[1+Delta*mu0 ; (1+Delta*mu0)*Jm; 1+Delta*mu1; 1+Delta*mu1];
gstjn=Gw.*Gstj;
h=Gw(end)-Gw(end-1);
[zeta eigenvec] = getZeta(PS,PJ,Delta*param(7),Gstj);
TPM_survival = getQ(PS,PJ,0,[],xGrid,gstjn,Gstj,zeta);

% Unconditional TPM
TPM = (1-Delta*param(7))*TPM_survival + Delta*param(7)*[TPM_death zeros(Nw,Nw) ; TPM_death zeros(Nw,Nw)];
[v,~] = eigs(sparse(TPM'),1,1);
pdf0 = v(1:Nw);
pdf1 = v((Nw+1):(2*Nw));
pdf=pdf0+pdf1;
pdf=pdf/sum(pdf);
cdf=cumsum(pdf);

% Aggregate wealth
aggw = pi*( Gw*pdf + Gw(end)*pdf(end)/(zeta-1));

% % compute top share thresholds
[~,ia,~] = unique(cdf); % select numerically unique elements only
top1thresh = interp1(cdf(ia),Gw(ia),1-0.01/pi,'spline'); 
top01thresh = interp1(cdf(ia),Gw(ia),1-0.001/pi,'spline'); 
top001thresh = interp1(cdf(ia),Gw(ia),1-0.0001/pi,'spline');
top0001thresh = interp1(cdf(ia),Gw(ia),1-0.00001/pi,'spline');

growth_top1 = sum(pdf0(Gw>=top1thresh))/(sum(pdf0(Gw>=top1thresh))+sum(pdf1(Gw>=top1thresh)));
growth_top01 = sum(pdf0(Gw>=top01thresh))/(sum(pdf0(Gw>=top01thresh))+sum(pdf1(Gw>=top01thresh)));
growth_top001 = sum(pdf0(Gw>=top001thresh))/(sum(pdf0(Gw>=top001thresh))+sum(pdf1(Gw>=top001thresh)));
growth_top0001 = sum(pdf0(Gw>=top0001thresh))/(sum(pdf0(Gw>=top0001thresh))+sum(pdf1(Gw>=top0001thresh)));


% compute top shares
top1share = getTopShares(0.01/pi,Gw,pdf',zeta);
top01share = getTopShares(0.001/pi,Gw,pdf',zeta);
top001share = getTopShares(0.0001/pi,Gw,pdf',zeta);
thetaProxy001 = 1+(log(top001share/top01share))/log(10);
thetaProxy01 = 1+(log(top01share/top1share))/log(10);

end

