function [tGrid rGrid RGrid mpkNetGrid aggKGrid aggQGrid top1 top01 top001 top0001 thetaProxy01Grid thetaProxy001Grid thetaProxy0001Grid totalGrid withinGrid betweenGrid top01shareBook]=getModelOutput(param,chi,rGrid)
global alpha Delta pi

%% Compute aggregate transition path conditional on r %%

% Time grid
T=100;
tGrid=0:Delta:100;
N=length(tGrid);

% Initialize grids
kGrid = repmat([0 0]',[1 N]);
qGrid = repmat([0 0]',[1 N]);
gGrid = repmat([0 0]',[1 N]);
iGrid = repmat([0 0]',[1 N]);
hGrid = repmat(0,[1 N]);

% Algorithm for transition path
[Q0Temp Q1Temp QTemp g0Temp g1Temp D0Temp D1Temp DTemp i0Temp i1Temp levQ0Temp levQ1Temp levD0Temp levD1Temp epy0Temp epy1Temp speed0Temp speed1Temp K0Temp K1Temp KTemp MPKTemp MPKnetTemp thetaTemp kappaLevM0Temp WTemp WETemp WE0Temp WLTemp DETemp DMTemp DDTemp]=getSS(param,chi,rGrid(1));
kGrid(1:2,1)=[K0Temp K1Temp];
for n=1:N
    %disp(round(100*n/N))
    [Q0Temp Q1Temp QTemp g0Temp g1Temp D0Temp D1Temp DTemp i0Temp i1Temp levQ0Temp levQ1Temp levD0Temp levD1Temp epy0Temp epy1Temp speed0Temp speed1Temp K0Temp K1Temp KTemp MPKTemp MPKnetTemp thetaTemp kappaLevM0Temp WTemp WETemp WE0Temp WLTemp DETemp DMTemp DDTemp]=getSS(param,chi,rGrid(n));
    terminalQ=[Q0Temp Q1Temp];
    initialK=kGrid(1:2,n)';
    [kGridTemp qGridTemp iGridTemp gGridTemp hGridTemp]=getMIT(param,chi,rGrid(n),initialK,terminalQ);
    gGrid(:,n)=gGridTemp(:,1);
    iGrid(:,n)=iGridTemp(:,1);
    qGrid(:,n)=qGridTemp(:,1);
    hGrid(n)=hGridTemp(1);
    if n<N
        kGrid(:,n+1)=kGridTemp(:,2);
    end
end

% Equilibrium objects
aggQGrid = sum(qGrid.*kGrid,1)./sum(kGrid,1);
aggKGrid = sum(kGrid,1);
mpkGrid = alpha*(sum(kGrid,1)).^(alpha-1)*(1-pi)^(1-alpha);
mpkNetGrid = mpkGrid - (kGrid(1,:)./sum(kGrid,1)).*(iGrid(1,:)-gGrid(1,:)-param(3)*(param(4)-1)) - (1-(kGrid(1,:)./sum(kGrid,1))).*(iGrid(2,:)-gGrid(2,:));
YGrid = (sum(kGrid,1)).^(alpha)*(1-pi)^(1-alpha);
wGrid = (1-alpha)*(sum(kGrid,1)).^(alpha)*(1-pi)^(-alpha);
WGrid = sum(qGrid.*kGrid,1);
revalGrid = [(aggQGrid(2:end)-aggQGrid(1:end-1))./aggQGrid(1:end-1) 0];
RGrid=rGrid;
RGrid(1:end-1) = rGrid(1:end-1) + (1/Delta)*revalGrid(1:end-1);

%% Construct entrepreneur wealth series %%
[Q0Temp Q1Temp QTemp g0Temp g1Temp D0Temp D1Temp DTemp i0Temp i1Temp levQ0Temp levQ1Temp levD0Temp levD1Temp epy0Temp epy1Temp speed0Temp speed1Temp K0Temp K1Temp KTemp MPKTemp MPKnetTemp thetaTemp kappaLevM0Temp WTemp WETemp WE0Temp WLTemp DETemp DMTemp DDTemp]=getSS(param,chi,rGrid(1));
WEGrid = repmat([0 0]',[1 N]);
revalEGrid = repmat(0,[1 N]);
WEGrid(:,1) = [WE0Temp WETemp-WE0Temp];

for n=1:N-1
    %disp(round(100*n/N))
    epy0Temp = ((1+param(5))*(mpkGrid(n)-iGrid(1,n)) + param(5)*(gGrid(1,n)-rGrid(n+1)))/( (1+param(5))*qGrid(1,n)-param(5));
    reval0Temp = (1+param(5))*(qGrid(1,n+1)-qGrid(1,n))/( (1+param(5))*qGrid(1,n)-param(5));
    epy1Temp = ((1+param(5))*(mpkGrid(n)-iGrid(2,n)) + param(5)*(gGrid(2,n)-rGrid(n+1)))/( (1+param(5))*qGrid(2,n)-param(5));
    reval1Temp = (1+param(5))*(qGrid(2,n+1)-qGrid(2,n))/( (1+param(5))*qGrid(2,n)-param(5));
    JTemp = (rGrid(n+1)- epy0Temp - gGrid(1,n))/param(3);
    
    WEGrid(1,n+1) = (1+Delta*(epy0Temp-param(9)+gGrid(1,n)-param(3)-param(7))+reval0Temp)*WEGrid(1,n) + Delta*param(7)*param(6)*pi*((1+param(5))*qGrid(1,n)-param(5))/(1+param(5));
    WEGrid(2,n+1) = (1+Delta*(epy1Temp-param(9)+gGrid(2,n)-param(7))+reval1Temp)*WEGrid(2,n) + Delta*param(3)*(1+JTemp)*WEGrid(1,n);
    
    revalEGrid(n) = (reval0Temp*WEGrid(1,n) + reval1Temp*WEGrid(2,n))/sum(WEGrid(:,n));
end

WMGrid = WGrid-sum(WEGrid,1);

%% Worker wealth series %%
revalMGrid = repmat(0,[1 N]);
revalHGrid = repmat(0,[1 N]);
WLGrid = repmat(0,[1 N]);
WLGrid(1) = WLTemp;
WLTotGrid = repmat(0,[1 N]);
WLTotGrid(1) = (param(7)*(1-pi)*wGrid(1)/rGrid(1))/(param(7)+param(8)-rGrid(1));

for n=1:N-1
    %disp(round(100*n/N))
    revalMGrid(n) = (WGrid(n)/WMGrid(n))*revalGrid(n) + (1-WGrid(n)/WMGrid(n))*revalEGrid(n);
    revalHGrid(n) = (hGrid(n+1)-hGrid(n))/hGrid(n);
    WLGrid(n+1) = WLGrid(n)*(1+Delta*( rGrid(n+1) - param(8) - param(7))+ revalMGrid(n))+Delta*((1-pi)*wGrid(n)-param(8)*(1-pi)*wGrid(n)/rGrid(n) );
    WLTotGrid(n+1) = WLTotGrid(n)*(1+Delta*( rGrid(n+1) - param(8) - param(7)) + (WLGrid(n)/WLTotGrid(n))*revalMGrid(n) + (1-WLGrid(n)/WLTotGrid(n))*revalHGrid(n) ) + Delta*param(7)*(1-pi)*wGrid(n)/rGrid(n) ;
end

%% Construct domestic wealth series %%
WDGrid = WLGrid+sum(WEGrid,1);
WDTotGrid = WLTotGrid+sum(WEGrid,1);

%% Construct foreigner savings and wealth %%
WFGrid = WGrid-WDGrid;
SfGrid = [ WFGrid(2:end)-WFGrid(1:end-1).*(1+revalMGrid(1:end-1))+WFGrid(1:end-1).*(param(7)-rGrid(1:end-1)) WFGrid(end).*(param(7)-rGrid(end))];

%% Evolution of the wealth distribution %%

% Initial de-meaned wealth distribution
[Q0Temp Q1Temp QTemp g0Temp g1Temp D0Temp D1Temp DTemp i0Temp i1Temp levQ0Temp levQ1Temp levD0Temp levD1Temp epy0Temp epy1Temp speed0Temp speed1Temp K0Temp K1Temp KTemp MPKTemp MPKnetTemp thetaTemp kappaLevM0Temp WTemp WETemp WE0Temp WLTemp DETemp DMTemp DDTemp]=getSS(param,chi,rGrid(1));
w0 = (param(6)*(levQ0Temp)/(1+param(5)))/sum(WEGrid(:,1));
mu0=epy0Temp+g0Temp-param(9);
mu1=epy1Temp+g1Temp-param(9);
Jm = 1+(rGrid(1)-epy0Temp-g0Temp)/param(3);
[eigenvecTemp Gw zeta pdfTemp pdf0Temp pdf1Temp cdfTemp aggwTemp top1shareTemp top01shareTemp top001shareTemp thetaProxy01TempthetaProxy001Temp] = getDistSS(param,mu0,mu1,w0,Jm);
Nw = length(Gw);

% Initialize grids
pdf01Mat = repmat(zeros(2*Nw,1),[1 N]);
pdf01Mat(:,1)=[pdf0Temp;pdf1Temp]/sum([pdf0Temp;pdf1Temp]);
topShareGrid = repmat(zeros(4,1),[1 N]);
aggwGrid = repmat(0,[1 N]);
totalGrid = repmat(0,[1 N]);
withinGridTemp = repmat(0,[1 N]);
demogGrid = repmat(0,[1 N]);
top01shareBook = repmat(0,[1 N]);

% Iterate wealth distribution forward
for n=1:(N-1)
    %disp(round(100*n/N))
    
    % Compute drifts and jumps
    w0Temp = (param(6)*((1+param(5))*qGrid(1,n)-param(5))/(1+param(5)))/sum(WEGrid(:,n));    
    epy0Temp = ((1+param(5))*(mpkGrid(n)-iGrid(1,n)) + param(5)*(gGrid(1,n)-rGrid(n+1)))/( (1+param(5))*qGrid(1,n)-param(5));
    reval0Temp = (1+param(5))*(qGrid(1,n+1)-qGrid(1,n))/( (1+param(5))*qGrid(1,n)-param(5));
    epy1Temp = ((1+param(5))*(mpkGrid(n)-iGrid(2,n)) + param(5)*(gGrid(2,n)-rGrid(n+1)))/( (1+param(5))*qGrid(2,n)-param(5));
    reval1Temp = (1+param(5))*(qGrid(2,n+1)-qGrid(2,n))/( (1+param(5))*qGrid(2,n)-param(5));
    JTemp = (rGrid(n+1)- epy0Temp - gGrid(1,n))/param(3);
    gWETemp = (sum(WEGrid(:,n+1))-sum(WEGrid(:,n)))/sum(WEGrid(:,n));
    
    % Compute top shares
    pdf0Temp = pdf01Mat(1:Nw,n);
    pdf1Temp = pdf01Mat((Nw+1):(2*Nw),n);
    pdfTemp = pdf0Temp+pdf1Temp;
    cdfTemp=cumsum(pdfTemp);
    aggwGrid(n) = Gw*pdfTemp + Gw(end)*pdfTemp(end)/(zeta-1);

    [~,ia,~] = unique(cdfTemp);
    top1threshTemp = interp1(cdfTemp(ia),Gw(ia),1-0.01/pi,'spline'); 
    top01threshTemp = interp1(cdfTemp(ia),Gw(ia),1-0.001/pi,'spline'); 
    top001threshTemp = interp1(cdfTemp(ia),Gw(ia),1-0.0001/pi,'spline');
    top0001threshTemp = interp1(cdfTemp(ia),Gw(ia),1-0.00001/pi,'spline');
    share0Temp = sum(pdf0Temp(Gw>=top01threshTemp))/sum(pdfTemp(Gw>=top01threshTemp));
    
    top1shareTemp = getTopShares(0.01/pi,Gw,pdfTemp',zeta);
    top01shareTemp = getTopShares(0.001/pi,Gw,pdfTemp',zeta);
    top001shareTemp = getTopShares(0.0001/pi,Gw,pdfTemp',zeta);
    top0001shareTemp = getTopShares(0.00001/pi,Gw,pdfTemp',zeta);
    topShareGrid(:,n) = [top0001shareTemp top001shareTemp top01shareTemp top1shareTemp]';
    
    growth_top01 = sum(pdf0Temp(Gw>=top01threshTemp))/(sum(pdf0Temp(Gw>=top01threshTemp))+sum(pdf1Temp(Gw>=top01threshTemp)));
    qTopTemp = growth_top01*( (1+param(5))*qGrid(1,n)-param(5)) + (1-growth_top01)*( (1+param(5))*qGrid(2,n)-param(5));
    qTemp = (kGrid(1,n)*qGrid(1,n) + kGrid(2,n)*qGrid(2,n))/(kGrid(1,n)+kGrid(2,n));
    top01shareBook(n) = top01shareTemp*(qTemp/qTopTemp);
    
    % Within/between decomposition
    withinGridTemp(n) = rGrid(n)-param(9)+(1/Delta)*(share0Temp*((1+param(5))*(qGrid(1,n+1)-qGrid(1,n))/( (1+param(5))*qGrid(1,n)-param(5))) + (1-share0Temp)*((1+param(5))*(qGrid(2,n+1)-qGrid(2,n))/( (1+param(5))*qGrid(2,n)-param(5)))- gWETemp);
    demogGrid(n) = -(1-top01threshTemp./(top01shareTemp/0.001))*param(7);
    
    % TPM conditional on birth
    TPM_death = zeros(Nw);
    ind0 = find(Gw < w0Temp, 1, 'last');
    if isempty(ind0) % x0 is below smallest grid point
        TPM_death(:,1) = 1;
    elseif ind0 < Nw % x0 is strictly inside grid
        theta0 = (w0Temp-Gw(ind0))/(Gw(ind0+1)-Gw(ind0));
        TPM_death(:,ind0) = 1-theta0; % convex combination
        TPM_death(:,ind0+1) = theta0;
    else % x0 is above largest grid
        TPM_death(:,end) = 1;
    end

    % TPM conditional on surviving
    PS=[ 1-Delta*param(3) Delta*param(3); 0 1];
    PJ=1;
    xGrid=Gw;
    Gstj=[1+Delta*(epy0Temp+gGrid(1,n)-param(9))+reval0Temp-gWETemp ; (1+Delta*(epy0Temp+gGrid(1,n)-param(9))+reval0Temp-gWETemp)*(1+JTemp); 1+Delta*(epy1Temp+gGrid(2,n)-param(9))+reval1Temp-gWETemp; 1+Delta*(epy1Temp+gGrid(2,n)-param(9))+reval1Temp-gWETemp];
    gstjn=Gw.*Gstj;
    TPM_survival = getQ(PS,PJ,0,[],xGrid,gstjn,Gstj,zeta);

    % Unconditional TPM
    TPM = (1-Delta*param(7))*TPM_survival + Delta*param(7)*[TPM_death zeros(Nw,Nw) ; TPM_death zeros(Nw,Nw)];
    
    % Update pdf
    pdf01Mat(:,n+1)=sparse(TPM')*pdf01Mat(:,n);
end
aggwGrid(end)=aggwGrid(end-1);

% Top share series
relAdj = sum(WEGrid,1)./WGrid;
top0001=topShareGrid(1,:).*relAdj;
top001=topShareGrid(2,:).*relAdj;
top01=topShareGrid(3,:).*relAdj;
top1=topShareGrid(4,:).*relAdj;
top0001(end)=topShareGrid(1,end-1);
top001(end)=topShareGrid(2,end-1);
top01(end)=topShareGrid(3,end-1);
top1(end)=topShareGrid(4,end-1);
top01shareBook = top01shareBook.*relAdj;
top01shareBook(end)=top01shareBook(end-1);

withinGrid=withinGridTemp + (1/Delta)*[(sum(WEGrid(:,2:end))-sum(WEGrid(:,1:end-1)) )./sum(WEGrid(:,1:end-1)) - (WGrid(2:end)-WGrid(1:end-1))./WGrid(1:end-1) 0];
withinGrid(end)=withinGridTemp(end-1);
demogGrid(end)=demogGrid(end-1);
totalGrid=(1/Delta)*[(top01(2:end)-top01(1:end-1))./top01(1:end-1) 0];
betweenGrid=totalGrid-withinGrid;

thetaProxy0001Grid = 1+(log(topShareGrid(1,:)./topShareGrid(2,:)))/log(10);
thetaProxy001Grid = 1+(log(topShareGrid(2,:)./topShareGrid(3,:)))/log(10);
thetaProxy01Grid = 1+(log(topShareGrid(3,:)./topShareGrid(4,:)))/log(10);

end