function [Q0 Q1 Q g0 g1 D0 D1 D i0 i1 levQ0 levQ1 levD0 levD1 epy0 epy1 speed0 speed1 K0 K1 K MPK MPKnet theta kappaLevM0 W WE WE0 WL DE DM DD]=getSS(param,chi,r)
global alpha pi

% Solve using non-linear solver for [Q0 Q1 K0 K1]
if chi<Inf
   solverFun = @(paramSolver) [ alpha*(paramSolver(3)+paramSolver(4))^(alpha-1)*(1-pi)^(1-alpha) - r  + param(3)*(param(4)*paramSolver(2)-1) - (r+param(3)-param(1))*(paramSolver(1)-1) + 0.5*(paramSolver(1)-1)^2/chi ; ...
                                 alpha*(paramSolver(3)+paramSolver(4))^(alpha-1)*(1-pi)^(1-alpha) - r - (r-param(2))*(paramSolver(2)-1) + 0.5*(paramSolver(2)-1)^2/chi ; ...
                                 param(7)*pi*param(6) + (param(1) + (paramSolver(1)-1)/chi-param(3)-param(7))*paramSolver(3) ;
                                 param(3)*param(4)*paramSolver(3) + (param(2) + (paramSolver(2)-1)/chi-param(7))*paramSolver(4) ];    
    options = optimset('Display','off');                         
    paramSolverStar = fsolve(solverFun,[1 1 1 1],options);
    K = paramSolverStar(3)+paramSolverStar(4);
    MPK = alpha*K^(alpha-1)*(1-pi)^(1-alpha);
    Q1 = 1 + chi*(r-param(2) - sqrt((r-param(2))^2 - (MPK-r)/(0.5*chi)));
    Q0 = 1 + chi*(r+param(3)-param(1) - sqrt((r+param(3)-param(1))^2 - (MPK-r+param(3)*(param(4)*Q1-1))/(0.5*chi)));
    g0 = param(1) + (Q0-1)/chi;
    g1 = param(2) + (Q1-1)/chi;
    i0 = g0 + (chi/2)*(g0-param(1))^2;
    i1 = g1 + (chi/2)*(g1-param(2))^2;  
else
    solverFun = @(paramSolver) [ alpha*(paramSolver(3)+paramSolver(4))^(alpha-1)*(1-pi)^(1-alpha) - r + param(1) + param(3)*(param(4)*paramSolver(2)-1) - (r+param(3)-param(1))*(paramSolver(1)-1) ; ...
                                 alpha*(paramSolver(3)+paramSolver(4))^(alpha-1)*(1-pi)^(1-alpha) - r + param(2)- (r-param(2))*(paramSolver(2)-1)  ; ...
                                 param(7)*pi*param(6) + (param(1) -param(3)-param(7))*paramSolver(3) ;
                                 param(3)*param(4)*paramSolver(3) + (param(2)-param(7))*paramSolver(4) ];
    options = optimset('Display','off');                         
    paramSolverStar = fsolve(solverFun,[1 1 1 1],options);
    K = paramSolverStar(3)+paramSolverStar(4);
    MPK = alpha*K^(alpha-1)*(1-pi)^(1-alpha);
    Q1 =  (MPK-param(2))/(r-param(2));
    Q0 =  (MPK - param(1) + param(3)*param(4)*Q1)/(r+param(3)-param(1));
    g0 =  param(1);
    g1 =  param(2);
    i0 =  g0;
    i1 =  g1;
end

% Aggregate objects
D1 =   1/(r-g1);
D0 =  (1/(r-g0+param(3)))*(1+param(3)*param(4)*(Q1/Q0)*D1);
K0 =  (param(7)*pi*param(6))/(param(7)-g0+param(3));
K1 =  (param(3)*param(4)*K0)/(param(7)-g1);
K =  K0+K1;
K0share =  K0/K;
Q =  K0share*Q0 + (1-K0share)*Q1;
D =  K0share*(Q0/Q)*D0 + (1-K0share)*(Q1/Q)*D1;
levQ0 =  (1+param(5))*Q0-param(5);
levQ1 =  (1+param(5))*Q1-param(5);
levD0 =  ((1+param(5))*Q0/((1+param(5))*Q0-param(5)))*D0;
levD1 =  ((1+param(5))*Q1/((1+param(5))*Q1-param(5)))*D1;
epy0 =  ((1+param(5))*(MPK-i0) + param(5)*(g0-r))/levQ0;
epy1 =  ((1+param(5))*(MPK-i1) + param(5)*(g1-r))/levQ1;
speed0 =  epy0 + g0 - param(9);
speed1 =  epy1 + g1 - param(9);
MPKnet =  MPK - (K0share*(i0-g0-param(3)*(param(4)-1)) + (1-K0share)*(i1-g1));
theta = speed0/(param(3)+param(7));
kappaLevM0 = param(5)/levQ0;
w=(1-alpha)*(K^alpha)*((1-pi)^(-alpha));
W=Q*K;
WE = param(7)*param(6)*pi*(levQ0/(1+param(5)))/(param(7)+param(9)-r);
WE0 = param(7)*param(6)*pi*(levQ0/(1+param(5)))/(param(7)+param(3)+param(9)-epy0-g0);
WL=((1-pi)*(w/r)*(r-param(8)))/(param(7)+param(8)-r);
DE = [levD0 levD1]*[WE0/WE (1-WE0/WE) ]';
DM = (D-(WE/W)*DE)/(1-(WE/W));
DD = (WE/(WL+WE))*DE+(WL/(WL+WE))*DM;

end