/***************************************************************************************************
TABLE C.IX ENTREPRENEURS IN THE TOP PERCENTILES (SCF, 2016)
***************************************************************************************************/
import delimited using "$MyPath/data/scf/p16i6.csv", case(preserve) clear
tempfile temp
save `temp'

import delimited using "$MyPath/data/scf/rscfp2016.csv", case(preserve) clear
merge 1:1 Y1 using `temp'
gen entrep = (X3104 == 1) * (X3105 > 0) * (X3108 == 1 | X3108 == 2) * (X3119 ~= 40)
gen legalForm = 1 if X3119==2
replace legalForm = 2 if X3119==1 | X3119==11
replace legalForm = 3 if X3119==3
replace legalForm = 4 if X3119==4
replace legalForm = 0 if entrep==0


foreach percentile in all 9900 9990 9999{
	preserve
	if "`percentile'" != "all"{
		_pctile networth [aw = wgt], p(`=`percentile' / 100')
		keep if networth > r(r1)
	}
	collapse (sum) wgt, by(legalForm)
	egen t = sum(wgt)
	gen variable = 1 - wgt / t if legalForm == 0
	replace variable = wgt / t / variable[1] if legalForm > 0
	gen percentile = "`percentile'"
	tempfile temp`percentile'
	save `temp`percentile''
	restore
}
drop _all
foreach percentile in all 9900 9990 9999{
	append using `temp`percentile''
}
keep legalForm percentile variable
reshape wide variable, i(legalForm) j(percentile) string
gen label = "Entrepreneurs" if legalForm == 0
replace label = "\quad Sole proprietorship" if legalForm == 1
replace label = "\quad Partnership" if legalForm == 2
replace label = "\quad S corporation" if legalForm == 3
replace label = "\quad Other corporations" if legalForm == 4
format variable* %9.2fc
listtab label variableall variable9900 variable9990 variable9999 using "$MyPath/Output/Tables/TableCVI_1.tex" if _n == 1, rstyle(tabular) replace
listtab label variableall variable9900 variable9990 variable9999 using "$MyPath/Output/Tables/TableCVI_2.tex" if _n > 1, rstyle(tabular) replace